#Include Once "../../md/helper/mdThreaded.bi"
#Include Once "md/util/mdList.bi"

mdListDeclare(String)
mdThreadedDeclare(Long)
mdThreadedDeclare(String)
mdThreadedDeclare(mdListString)

Type TestCaseThreaded Extends Object
	As mdThreaded(Long) longValue
	As mdThreaded(String) stringValue
	As mdThreaded(mdListString) listValue
End Type

Type TestCaseUnThreaded Extends Object
	As Long longValue
	As String stringValue
	As mdListString listValue
End Type

#Define USED_TYPE TestCaseUnThreaded

Dim Shared As USED_TYPE clazz
Dim As Any Ptr thread
Dim As Integer count


#Print TypeOf(clazz.listValue.getValue())

Sub myThread(ByVal Parameter as Any Ptr)
	Do 'alle 100ms einen "*" ausgeben
		Dim As Integer size
		mdThreaded_Get(clazz.listValue, .size(), size)
		clazz.stringValue.setValue(Str(size))
		If clazz.listValue.getValue().isEmpty() Then
			clazz.listValue.getValue().remove(0)
		EndIf
		Sleep 100, 1
		If clazz.longValue.getValue() = 1 Then 'abbrechen wenn 1
			Exit Do
		EndIf
	Loop
End Sub

clazz.longValue.setValue(0)


thread = ThreadCreate(@myThread)
Do  'alle 50ms einen "." ausgeben
	clazz.stringValue.setValue("")
	For i As Integer = 0 To count
		clazz.listValue.getValue().add(Str(i))
	Next
	Sleep 50, 1
	Print clazz.stringValue.getValue()
	count += 1
Loop Until count = 100

clazz.longValue.setValue(1) 'MyThread abbrechen

Print
Print "Beendevorgang begonnen"
ThreadWait(thread) 'warten bis MyThread endet
Print "Thread beendet"

Sleep


